unit TreeSeguranca;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, UClassSeguranca, IBDatabase, Db, Menus, IBQuery;

type
  TTreeSeguranca = class(TTreeView)
  private
    FActive: Boolean;
    FpUsuario: String;
    FpFormulario: TForm;
    FDataSource: TDataSource;
    procedure SetActive(const Value: Boolean);

    Function  AddItem(mitem : TTreeNode; mtag : Integer) : TTreeNode;
    procedure Desmarcar;
    procedure SetpUsuario(const Value: String);
    procedure SetpFormulario(const Value: TForm);
    procedure SetDataSource(const Value: TDataSource);
    Function  TiraE(mcaption : String) : String;

    { Private declarations }
  protected
    { Protected declarations }
    procedure DblClick; override;

  public
    { Public declarations }
     procedure AtivaTree;
     procedure Salvar;
     property  pUsuario : String read FpUsuario write SetpUsuario;
     property  pFormulario : TForm read FpFormulario write SetpFormulario;
  published
    { Published declarations }
     property DataSource  : TDataSource read FDataSource write SetDataSource;
     property Active      : Boolean read FActive write SetActive;
  end;

procedure Register;

var
   oUsuario    : TSeguranca;
   ListUsuario : Tlist;
   mForm: TForm;
   mpos        : Integer;

implementation

// constantes
const Main       = 0;
const DesMain    = 5;

const Cadastro    = 1;
const DesCadastro = 6;

const Relatorio    = 2;
const DesRelatorio = 7;

const Marcado    = 3;
const DesMarcado = 4;

const Grava      = 1;
const NaoGrava   = 0;


// registro do componente
procedure Register;
begin
  RegisterComponents('Galf', [TTreeSeguranca]);
end;

{ TTreeSeguranca }

// procedure para ativar a Tree pegando todos os elementos do menu passados
procedure TTreeSeguranca.AtivaTree;
var
  NewNode, Menu : TTreeNode;
  mtag   : Integer;
  mlinha : TSeguranca;
begin
   Items.Clear;

   mForm := pFormulario;

   // pego as informacoes do usuario
   oUsuario := nil;
   oUsuario := TSeguranca.Create;
   oUsuario.DataSource := DataSource;

   ListUsuario     := oUsuario.GetSegurancaList(pUsuario);

   // monto a tree
   mpos := 0;

   Menu               := Items.AddChild(nil, 'Menu Principal');
   Menu.ImageIndex    := Main;
   Menu.SelectedIndex := Main;
   Menu.StateIndex    := -1;

   While mpos <= mForm.ComponentCount-1 Do
   Begin
      If mForm.Components[mpos] is TMenuItem then
      Begin
            mtag := TMenuItem(mForm.Components[mpos]).tag;

            If (mtag <> 0) Then
            Begin
               If ((mtag >= 10) and (mtag <= 99)) Then
               Begin
                  // menu principal
                  NewNode := Items.AddChild(Menu, TiraE(TMenuItem(mForm.Components[mpos]).Caption));

                  NewNode.Data := TSeguranca.Pesquisa(ListUsuario, pUsuario, mtag);
                  mlinha       := NewNode.Data;

                  If mlinha.le_acesso = 0 Then
                  Begin
                     NewNode.ImageIndex    := DesMain;
                     NewNode.SelectedIndex := DesMain;
                     NewNode.StateIndex    := NaoGrava;
                  End
                  Else
                  Begin
                     NewNode.ImageIndex    := Main;
                     NewNode.SelectedIndex := Main;
                     NewNode.StateIndex    := Grava;
                  End;

                  Inc(mpos);
               End
               Else
               Begin
                  AddItem(NewNode,mtag);
               End;     // if tag > 0 and < 10
            End         // if tag <> 0
            Else
               Inc(mpos);
      End               // if components
      Else
         Inc(mpos);
   End;
end;


Function TTreeSeguranca.AddItem(mitem : TTreeNode; mtag : Integer) : TTreeNode;
   function Ret_Status(mtipo, mstatus, mimagem : Integer; mprincipal : Boolean) : Integer;
   Begin
      case mtipo Of
         1 :  // cadastro
            If (mimagem = 1) or (mimagem = 2) Then   // imagem
            Begin
               If mstatus = 0 then
               Begin
                  If mprincipal Then
                     Result := DesCadastro
                  Else
                     Result := DesMarcado
               End
               Else
               Begin
                  If mprincipal Then
                     Result := Cadastro
                  Else
                     Result := Marcado
               End
            End
            Else  // if 3
               If mstatus = 0 then
                  Result := NaoGrava
               Else
                  Result := Grava;

         2 : // relatorio
            If (mimagem = 1) or (mimagem = 2) Then   // imagem
            Begin
               If mstatus = 0 then
               Begin
                  If mprincipal Then
                     Result := DesRelatorio
                  Else
                     Result := DesMarcado;
               End
               Else
               Begin
                  If mprincipal Then
                     Result := Relatorio
                  Else
                     Result := Marcado;
               End;
            End
            Else  // if 3
               If mstatus = 0 then
                  Result := NaoGrava
               Else
                  Result := Grava;
            End;
   End;

{=======================================================================}
var
   n2, n3 : TTreeNode;
   mtag_aux : String;
   mlength, mtag1, mHelpContext  : Integer;
   mlinha : TSeguranca;
   mcaption : String;

// Function TTreeSeguranca.AddItem(mitem : TTreeNode; mtag : Integer) : TTreeNode;
Begin
   mtag_aux := IntToStr(mtag);

   mlength  := Length(mtag_aux);

   mtag1    := TMenuItem(mForm.Components[mpos]).Tag;
   mcaption := TiraE(TMenuItem(mForm.Components[mpos]).Caption);
   mLinha   := TSeguranca.Pesquisa(ListUsuario, pUsuario, mtag1);
   mhelpcontext := TMenuItem(mForm.Components[mpos]).HelpContext;

   Case mhelpcontext Of
      1: Begin // cadastro
            n2      := Items.AddChild(mitem,mcaption);
            n2.Data := mLinha;

            n2.ImageIndex    := Ret_Status(mHelpContext,mLinha.le_acesso,1,True);
            n2.SelectedIndex := Ret_Status(mHelpContext,mLinha.le_acesso,2,True);
            n2.StateIndex    := Ret_Status(mHelpContext,mLinha.le_acesso,3,True);

            n3 := Items.AddChild(n2,'Incluir');
            n3.ImageIndex    := Ret_Status(mHelpContext,mLinha.le_inclusao,1,False);
            n3.SelectedIndex := Ret_Status(mHelpContext,mLinha.le_inclusao,2,False);
            n3.StateIndex    := Ret_Status(mHelpContext,mLinha.le_inclusao,3,False);

            n3 := Items.AddChild(n2,'Alterar');
            n3.ImageIndex    := Ret_Status(mHelpContext,mLinha.le_alteracao,1,False);
            n3.SelectedIndex := Ret_Status(mHelpContext,mLinha.le_alteracao,2,False);
            n3.StateIndex    := Ret_Status(mHelpContext,mLinha.le_alteracao,3,False);

            n3 := Items.AddChild(n2,'Excluir');
            n3.ImageIndex    := Ret_Status(mHelpContext,mLinha.le_exclusao,1,False);
            n3.SelectedIndex := Ret_Status(mHelpContext,mLinha.le_exclusao,2,False);
            n3.StateIndex    := Ret_Status(mHelpContext,mLinha.le_exclusao,3,False);

            Inc(mpos);
         End;

      2: begin // relatorio
            n2 := Items.AddChild(mitem,mcaption);
            n2.Data := mLinha;

            n2.ImageIndex    := Ret_Status(mHelpContext,mLinha.le_acesso ,1,True);
            n2.SelectedIndex := Ret_Status(mHelpContext,mLinha.le_acesso ,2,True);
            n2.StateIndex    := Ret_Status(mHelpContext,mLinha.le_acesso ,3,True);

            n3 := Items.AddChild(n2,'Permitir');
            n3.ImageIndex    := Ret_Status(mHelpContext,mLinha.le_relatorio,1,False);
            n3.SelectedIndex := Ret_Status(mHelpContext,mLinha.le_relatorio,2,False);
            n3.StateIndex    := Ret_Status(mHelpContext,mLinha.le_relatorio,3,False);

            Inc(mpos);
         end;

      3: begin // sub-menu
            mtag1 := Tag;
            n2    := Items.AddChild(mitem,mcaption);

            mLinha  := TSeguranca.Pesquisa(ListUsuario, pUsuario, mtag1);

            n2.Data := mLinha;
            If mlinha.le_acesso = 0 Then
            Begin
               n2.ImageIndex    := DesMain;
               n2.SelectedIndex := DesMain;
               n2.StateIndex    := NaoGrava;
            End
            Else
            Begin
               n2.ImageIndex    := Main;
               n2.SelectedIndex := Main;
               n2.StateIndex    := Grava;
            End;

            Inc(mpos);
            While (Copy(IntToStr(TMenuItem(mForm.Components[mpos]).Tag),1,mlength) =
                   mtag_aux) Do
            Begin
               mtag1 := TMenuItem(mForm.Components[mpos]).Tag;
               AddItem(n2,mtag1);
            End;
         end;
   End;
   Result := n2;
End;
{***************************************************************
* procedimentos das propriedades
****************************************************************}
procedure TTreeSeguranca.SetActive(const Value: Boolean);
begin
  FActive := Value;

  If FActive Then
     AtivaTree;
end;

// desmarca todas as linhas abaixo do menu informado
procedure TTreeSeguranca.Desmarcar;
Var
  mtotal, mImageIndex, i : Integer;
  mtxt : String;

Begin
   mtotal := Selected.Count -1;

   For i := 0 to mtotal Do
   Begin
      With Selected.Item[i] Do
      Begin
         mImageIndex := ImageIndex;
         mtxt        := Text;

         Case mImageIndex Of
            Marcado :
               Begin
                  ImageIndex    := DesMarcado;
                  SelectedIndex := DesMarcado;
                  StateIndex    := NaoGrava;
               End;

            Main :
               Begin
                  ImageIndex    := DesMain;
                  SelectedIndex := DesMain;
                  StateIndex    := NaoGrava;
               End;

            Relatorio :
               Begin
                  ImageIndex    := DesRelatorio;
                  SelectedIndex := DesRelatorio;
                  StateIndex    := NaoGrava;
               End;

           Cadastro :
               Begin
                  ImageIndex    := DesCadastro;
                  SelectedIndex := DesCadastro;
                  StateIndex    := NaoGrava;
               End;
         End;
      End;
   End;
End;

procedure TTreeSeguranca.SetpUsuario(const Value: String);
begin
  FpUsuario := Value;
end;

procedure TTreeSeguranca.SetpFormulario(const Value: TForm);
begin
  FpFormulario := Value;
end;

procedure TTreeSeguranca.Salvar;
var
  mcont, i : Integer;
  mnode    : TTreeNode;
  mdados   : Pointer;
begin
   mcont := Items.Count -1;

   For i := 1 to mcont Do
   Begin
      mnode := Items.Item[i];

      If (mnode.ImageIndex <> Marcado) and (mnode.ImageIndex <> DesMarcado) Then
      Begin
         TSeguranca(mnode.Data).le_usuario := pUsuario;
         oUsuario.Salvar(mnode.Data);
      End;
   End;
end;

procedure TTreeSeguranca.DblClick;
   // habilito ou desabilito no objeto da Tree com cast de TSeguranca os tipos propostos
   Procedure MarcaLinha(mText : String; mstatus : Integer);
   Begin
      TSeguranca(Selected.Parent.Data).le_acesso := 1;

      If mText = 'Incluir' Then
         TSeguranca(Selected.Parent.Data).le_inclusao  := mstatus
      Else If mText = 'Alterar' Then
         TSeguranca(Selected.Parent.Data).le_alteracao := mstatus
      Else If mText = 'Excluir' Then
         TSeguranca(Selected.Parent.Data).le_exclusao  := mstatus
      Else If mText = 'Permitir' Then
         TSeguranca(Selected.Parent.Data).le_relatorio := mstatus;

      // caso tenha abilitado alguma opcao de incluir/alterar/excluir ou relatorio
      // habilito o pai
      If mText = 'Permitir' Then
      Begin
         Selected.Parent.ImageIndex    := Relatorio;
         Selected.Parent.SelectedIndex := Relatorio;
         Selected.Parent.StateIndex    := Grava;
      End
      Else
      Begin
         Selected.Parent.ImageIndex    := Cadastro;
         Selected.Parent.SelectedIndex := Cadastro;
         Selected.Parent.StateIndex    := Grava;
      End;
   End;

var
   mImageIndex : Integer;

begin
   inherited;

   // nao  nenhuma opcao - menu principal, sub-menu, relatorio ou cadastro
   If Selected.StateIndex = -1 Then
      Exit;

   mImageIndex := Selected.ImageIndex;
   Case mImageIndex Of
      Marcado :
         Begin
            Selected.ImageIndex    := DesMarcado;
            Selected.SelectedIndex := DesMarcado;
            Selected.StateIndex    := NaoGrava;
            MarcaLinha(Selected.text ,0);
         End;

      DesMarcado :
         Begin
            Selected.ImageIndex    := Marcado;
            Selected.SelectedIndex := Marcado;
            Selected.StateIndex    := Grava;
            MarcaLinha(Selected.text ,1);
         End;

      Main :
         Begin

            Selected.ImageIndex    := DesMain;
            Selected.SelectedIndex := DesMain;
            Selected.StateIndex    := NaoGrava;
            TSeguranca(Selected.Data).le_acesso := 0;
            Desmarcar; // desmarca as opcoes que tiverem abaixo
         End;

      DesMain :
         Begin
            Selected.ImageIndex    := Main;
            Selected.SelectedIndex := Main;
            Selected.StateIndex    := Grava;
            TSeguranca(Selected.Data).le_acesso := 1;
         End;

      Relatorio :
         Begin
            Selected.ImageIndex    := DesRelatorio;
            Selected.SelectedIndex := DesRelatorio;
            Selected.StateIndex    := NaoGrava;
            TSeguranca(Selected.Data).le_acesso := 0;
            Desmarcar; // desmarca as opcoes que tiverem abaixo
         End;

      DesRelatorio :
         Begin
            Selected.ImageIndex    := Relatorio;
            Selected.SelectedIndex := Relatorio;
            Selected.StateIndex    := Grava;
            MarcaLinha(Selected.text ,1);
         End;

     DesCadastro :
         Begin
            Selected.ImageIndex    := Cadastro;
            Selected.SelectedIndex := Cadastro;
            Selected.StateIndex    := Grava;
            TSeguranca(Selected.Data).le_acesso := 1;
         End;

     Cadastro :
         Begin
            Selected.ImageIndex    := DesCadastro;
            Selected.SelectedIndex := DesCadastro;
            Selected.StateIndex    := NaoGrava;
            TSeguranca(Selected.Data).le_acesso := 0;
            Desmarcar;   // desmarca as opcoes que tiverem abaixo
         End;
   End;
end;

procedure TTreeSeguranca.SetDataSource(const Value: TDataSource);
begin
  FDataSource := Value;
end;

function TTreeSeguranca.TiraE(mcaption : String) : String;
Var
  i : Integer;
  mvolta : String;
begin
   mvolta := '';

   For i := 1 to Length(mcaption) Do
   Begin
      If mcaption[i] <> '&' Then
         mvolta := mvolta + mcaption[i]
   End;
   Result := mvolta;
end;

end.
